<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: PubSubClient Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classPubSubClient-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">PubSubClient Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aeb3b73c58a265de2192cda5021b55d38"><td class="memItemLeft" align="right" valign="top"><a id="aeb3b73c58a265de2192cda5021b55d38"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>PubSubClient</b> (<a class="el" href="classSocket.html">Socket</a> &amp;client)</td></tr>
<tr class="separator:aeb3b73c58a265de2192cda5021b55d38"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a85198d5b6590eb5e5fa034f9c96780"><td class="memItemLeft" align="right" valign="top"><a id="a5a85198d5b6590eb5e5fa034f9c96780"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>PubSubClient</b> (std::string ip, uint16_t port)</td></tr>
<tr class="separator:a5a85198d5b6590eb5e5fa034f9c96780"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef3210df9c46325888756ea9065e74ea"><td class="memItemLeft" align="right" valign="top"><a id="aef3210df9c46325888756ea9065e74ea"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>PubSubClient</b> (std::string ip, uint16_t port, <a class="el" href="classSocket.html">Socket</a> &amp;client)</td></tr>
<tr class="separator:aef3210df9c46325888756ea9065e74ea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a21e8a6cfeb5efea893a71cdaa82fa6c0"><td class="memItemLeft" align="right" valign="top"><a id="a21e8a6cfeb5efea893a71cdaa82fa6c0"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>PubSubClient</b> (std::string ip, uint16_t port, MQTT_CALLBACK_SIGNATURE, <a class="el" href="classSocket.html">Socket</a> &amp;client)</td></tr>
<tr class="separator:a21e8a6cfeb5efea893a71cdaa82fa6c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa809b115adf6c551dee72d12ecfd8414"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classPubSubClient.html">PubSubClient</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#aa809b115adf6c551dee72d12ecfd8414">setServer</a> (std::string ip, uint16_t port)</td></tr>
<tr class="memdesc:aa809b115adf6c551dee72d12ecfd8414"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set server ip and Port of my MQTT server.  <a href="#aa809b115adf6c551dee72d12ecfd8414">More...</a><br /></td></tr>
<tr class="separator:aa809b115adf6c551dee72d12ecfd8414"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a115733ca6dd337362375d3c4a45300fe"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classPubSubClient.html">PubSubClient</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a115733ca6dd337362375d3c4a45300fe">setCallback</a> (MQTT_CALLBACK_SIGNATURE)</td></tr>
<tr class="memdesc:a115733ca6dd337362375d3c4a45300fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the callback function for incoming data.  <a href="#a115733ca6dd337362375d3c4a45300fe">More...</a><br /></td></tr>
<tr class="separator:a115733ca6dd337362375d3c4a45300fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a30e35b9461d26f3d10736ac39c9de418"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classPubSubClient.html">PubSubClient</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a30e35b9461d26f3d10736ac39c9de418">setClient</a> (<a class="el" href="classSocket.html">Socket</a> &amp;client)</td></tr>
<tr class="memdesc:a30e35b9461d26f3d10736ac39c9de418"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the socket, which we want to use for our MQTT communication.  <a href="#a30e35b9461d26f3d10736ac39c9de418">More...</a><br /></td></tr>
<tr class="separator:a30e35b9461d26f3d10736ac39c9de418"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae7a37521960b158aff48b7fa17d1e825"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#ae7a37521960b158aff48b7fa17d1e825">connect</a> (const char *id)</td></tr>
<tr class="memdesc:ae7a37521960b158aff48b7fa17d1e825"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect to a MQTT server.  <a href="#ae7a37521960b158aff48b7fa17d1e825">More...</a><br /></td></tr>
<tr class="separator:ae7a37521960b158aff48b7fa17d1e825"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83999f75903ea9ca9c9655f9631a4a71"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a83999f75903ea9ca9c9655f9631a4a71">connect</a> (const char *id, const char *user, const char *pass)</td></tr>
<tr class="memdesc:a83999f75903ea9ca9c9655f9631a4a71"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect to a MQTT server.  <a href="#a83999f75903ea9ca9c9655f9631a4a71">More...</a><br /></td></tr>
<tr class="separator:a83999f75903ea9ca9c9655f9631a4a71"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af659dd03043c52fbf662c4af13c18918"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#af659dd03043c52fbf662c4af13c18918">connect</a> (const char *id, const char *willTopic, uint8_t willQos, bool willRetain, const char *willMessage)</td></tr>
<tr class="memdesc:af659dd03043c52fbf662c4af13c18918"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect to a MQTT server.  <a href="#af659dd03043c52fbf662c4af13c18918">More...</a><br /></td></tr>
<tr class="separator:af659dd03043c52fbf662c4af13c18918"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae444eb4da7b7623a305ef1a66910f217"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#ae444eb4da7b7623a305ef1a66910f217">connect</a> (const char *id, const char *user, const char *pass, const char *willTopic, uint8_t willQos, bool willRetain, const char *willMessage)</td></tr>
<tr class="memdesc:ae444eb4da7b7623a305ef1a66910f217"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect to a MQTT server.  <a href="#ae444eb4da7b7623a305ef1a66910f217">More...</a><br /></td></tr>
<tr class="separator:ae444eb4da7b7623a305ef1a66910f217"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af482531348f9031f7713fdee5329d237"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#af482531348f9031f7713fdee5329d237">connect</a> ()</td></tr>
<tr class="memdesc:af482531348f9031f7713fdee5329d237"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect to a MQTT server with the with the previous settings. Note: do not call this function without settings, this will not work! For the very first connect process, use the connect function with parameters.  <a href="#af482531348f9031f7713fdee5329d237">More...</a><br /></td></tr>
<tr class="separator:af482531348f9031f7713fdee5329d237"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0d1c6de8a88a9f9fda04126c8cf2fe0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#ac0d1c6de8a88a9f9fda04126c8cf2fe0">disconnect</a> ()</td></tr>
<tr class="memdesc:ac0d1c6de8a88a9f9fda04126c8cf2fe0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Disconnect form MQTT server and close the socket.  <a href="#ac0d1c6de8a88a9f9fda04126c8cf2fe0">More...</a><br /></td></tr>
<tr class="separator:ac0d1c6de8a88a9f9fda04126c8cf2fe0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59500b307e27b6ec9007ef1f3a0c24db"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a59500b307e27b6ec9007ef1f3a0c24db">publish</a> (const char *topic, const char *payload)</td></tr>
<tr class="memdesc:a59500b307e27b6ec9007ef1f3a0c24db"><td class="mdescLeft">&#160;</td><td class="mdescRight">Publish a MQTT message.  <a href="#a59500b307e27b6ec9007ef1f3a0c24db">More...</a><br /></td></tr>
<tr class="separator:a59500b307e27b6ec9007ef1f3a0c24db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7daa0a786e0bcb8447cc2e9c5acaae7b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a7daa0a786e0bcb8447cc2e9c5acaae7b">publish</a> (const char *topic, const char *payload, bool retained)</td></tr>
<tr class="memdesc:a7daa0a786e0bcb8447cc2e9c5acaae7b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Publish a MQTT message.  <a href="#a7daa0a786e0bcb8447cc2e9c5acaae7b">More...</a><br /></td></tr>
<tr class="separator:a7daa0a786e0bcb8447cc2e9c5acaae7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a640422e51b06a9021140766928645a6d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a640422e51b06a9021140766928645a6d">publish</a> (const char *topic, const uint8_t *payload, unsigned int plength)</td></tr>
<tr class="memdesc:a640422e51b06a9021140766928645a6d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Publish a MQTT message.  <a href="#a640422e51b06a9021140766928645a6d">More...</a><br /></td></tr>
<tr class="separator:a640422e51b06a9021140766928645a6d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2cd5fb0bbd16f2b177faeda3ec3ca61"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#ad2cd5fb0bbd16f2b177faeda3ec3ca61">publish</a> (const char *topic, const uint8_t *payload, unsigned int plength, bool retained)</td></tr>
<tr class="memdesc:ad2cd5fb0bbd16f2b177faeda3ec3ca61"><td class="mdescLeft">&#160;</td><td class="mdescRight">Publish a MQTT message.  <a href="#ad2cd5fb0bbd16f2b177faeda3ec3ca61">More...</a><br /></td></tr>
<tr class="separator:ad2cd5fb0bbd16f2b177faeda3ec3ca61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62ae269568ef379fb21a434f7e6d4a06"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a62ae269568ef379fb21a434f7e6d4a06">subscribe</a> (const char *topic, bool ack=false)</td></tr>
<tr class="memdesc:a62ae269568ef379fb21a434f7e6d4a06"><td class="mdescLeft">&#160;</td><td class="mdescRight">Subscribe a MQTT topic.  <a href="#a62ae269568ef379fb21a434f7e6d4a06">More...</a><br /></td></tr>
<tr class="separator:a62ae269568ef379fb21a434f7e6d4a06"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af828241dd14833967c27b902b43b6491"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#af828241dd14833967c27b902b43b6491">unsubscribe</a> (const char *topic, bool ack=false)</td></tr>
<tr class="memdesc:af828241dd14833967c27b902b43b6491"><td class="mdescLeft">&#160;</td><td class="mdescRight">Unsubscribe a MQTT topic.  <a href="#af828241dd14833967c27b902b43b6491">More...</a><br /></td></tr>
<tr class="separator:af828241dd14833967c27b902b43b6491"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6178d5e981a461e53424e3158d63b0e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#af6178d5e981a461e53424e3158d63b0e">isSubscribeDone</a> ()</td></tr>
<tr class="memdesc:af6178d5e981a461e53424e3158d63b0e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check the state of subscription. If there was received a subscription ACK, we return a true here.  <a href="#af6178d5e981a461e53424e3158d63b0e">More...</a><br /></td></tr>
<tr class="separator:af6178d5e981a461e53424e3158d63b0e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3bd39e46772e74c818ebbfedd4fa076f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a3bd39e46772e74c818ebbfedd4fa076f">isUnsubscribeDone</a> ()</td></tr>
<tr class="memdesc:a3bd39e46772e74c818ebbfedd4fa076f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check the state of unsubscription. If there was received a unsubscription ACK, we return a true here.  <a href="#a3bd39e46772e74c818ebbfedd4fa076f">More...</a><br /></td></tr>
<tr class="separator:a3bd39e46772e74c818ebbfedd4fa076f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f2097ea474209f9454dbdcb671fa2e9"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a7f2097ea474209f9454dbdcb671fa2e9">connected</a> ()</td></tr>
<tr class="memdesc:a7f2097ea474209f9454dbdcb671fa2e9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check the connection to the MQTT server.  <a href="#a7f2097ea474209f9454dbdcb671fa2e9">More...</a><br /></td></tr>
<tr class="separator:a7f2097ea474209f9454dbdcb671fa2e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a7025562e55ee15fd4469b75d535b1d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a8a7025562e55ee15fd4469b75d535b1d">state</a> ()</td></tr>
<tr class="memdesc:a8a7025562e55ee15fd4469b75d535b1d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the current MYTT state form the instance.  <a href="#a8a7025562e55ee15fd4469b75d535b1d">More...</a><br /></td></tr>
<tr class="separator:a8a7025562e55ee15fd4469b75d535b1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49518d415ae1fc9a115712bb90bcbafb"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#a49518d415ae1fc9a115712bb90bcbafb">keepAliveChecker</a> ()</td></tr>
<tr class="memdesc:a49518d415ae1fc9a115712bb90bcbafb"><td class="mdescLeft">&#160;</td><td class="mdescRight">This is a Timer called routine, which checks the PING_outstanding flag. This flag is set in this function. We send a Keep alive message to the server here. If there is a data in, or output, or we receive the MQTT ping request, the flag will be set to false by other functions. This function is called every MQTT_KEEPALIVE interval. If the flag is still true, we have a error with the connection.  <a href="#a49518d415ae1fc9a115712bb90bcbafb">More...</a><br /></td></tr>
<tr class="separator:a49518d415ae1fc9a115712bb90bcbafb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac67061f0fdd7b98007f6f7501b6a5dbd"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPubSubClient.html#ac67061f0fdd7b98007f6f7501b6a5dbd">timeoutChecker</a> ()</td></tr>
<tr class="memdesc:ac67061f0fdd7b98007f6f7501b6a5dbd"><td class="mdescLeft">&#160;</td><td class="mdescRight">This is a Timer called routine, which is called, when we reach the timeout. Used is this function for all ACK commands, which comes over MQTT. Notice, that the KeepAlivePing has his own Timer, to prevent conflicts. Basically, if this function is called, we have detected a MQTT timeout!  <a href="#ac67061f0fdd7b98007f6f7501b6a5dbd">More...</a><br /></td></tr>
<tr class="separator:ac67061f0fdd7b98007f6f7501b6a5dbd"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:aa566055775e8c1519b834da048cbc68f"><td class="memItemLeft" align="right" valign="top"><a id="aa566055775e8c1519b834da048cbc68f"></a>
class&#160;</td><td class="memItemRight" valign="bottom"><b>PubSubClientTask</b></td></tr>
<tr class="separator:aa566055775e8c1519b834da048cbc68f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ae7a37521960b158aff48b7fa17d1e825"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae7a37521960b158aff48b7fa17d1e825">&#9670;&nbsp;</a></span>connect() <span class="overload">[1/5]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::connect </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Connect to a MQTT server. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">Device</td><td>id to identify this device. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success (true), or no success (false). </dd></dl>

</div>
</div>
<a id="a83999f75903ea9ca9c9655f9631a4a71"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a83999f75903ea9ca9c9655f9631a4a71">&#9670;&nbsp;</a></span>connect() <span class="overload">[2/5]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::connect </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>user</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>pass</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Connect to a MQTT server. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">Device</td><td>id to identify this device. [in] my user name. [in] my password. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success (true), or no success (false). </dd></dl>

</div>
</div>
<a id="af659dd03043c52fbf662c4af13c18918"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af659dd03043c52fbf662c4af13c18918">&#9670;&nbsp;</a></span>connect() <span class="overload">[3/5]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::connect </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>willTopic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>willQos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>willRetain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>willMessage</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Connect to a MQTT server. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">Device</td><td>id to identify this device. [in] last will: topic name. [in] last will: qos-level. [in] last will: as retained message. [in] last will: payload. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success (true), or no success (false). </dd></dl>

</div>
</div>
<a id="ae444eb4da7b7623a305ef1a66910f217"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae444eb4da7b7623a305ef1a66910f217">&#9670;&nbsp;</a></span>connect() <span class="overload">[4/5]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::connect </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>user</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>pass</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>willTopic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>willQos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>willRetain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>willMessage</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Connect to a MQTT server. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">Device</td><td>id to identify this device. [in] my user name. [in] my password. [in] last will: topic name. [in] last will: qos-level. [in] last will: as retained message. [in] last will: payload. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success (true), or no success (false). </dd></dl>

</div>
</div>
<a id="af482531348f9031f7713fdee5329d237"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af482531348f9031f7713fdee5329d237">&#9670;&nbsp;</a></span>connect() <span class="overload">[5/5]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::connect </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Connect to a MQTT server with the with the previous settings. Note: do not call this function without settings, this will not work! For the very first connect process, use the connect function with parameters. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">N/A</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success (true), or no success (false). </dd></dl>

</div>
</div>
<a id="a7f2097ea474209f9454dbdcb671fa2e9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7f2097ea474209f9454dbdcb671fa2e9">&#9670;&nbsp;</a></span>connected()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::connected </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Check the connection to the MQTT server. </p>
<dl class="section return"><dt>Returns</dt><dd>connected (true/false) </dd></dl>

</div>
</div>
<a id="ac0d1c6de8a88a9f9fda04126c8cf2fe0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac0d1c6de8a88a9f9fda04126c8cf2fe0">&#9670;&nbsp;</a></span>disconnect()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PubSubClient::disconnect </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Disconnect form MQTT server and close the socket. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="af6178d5e981a461e53424e3158d63b0e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af6178d5e981a461e53424e3158d63b0e">&#9670;&nbsp;</a></span>isSubscribeDone()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::isSubscribeDone </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Check the state of subscription. If there was received a subscription ACK, we return a true here. </p>
<dl class="section return"><dt>Returns</dt><dd>Is subscription validated with ACK (true/false) </dd></dl>

</div>
</div>
<a id="a3bd39e46772e74c818ebbfedd4fa076f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3bd39e46772e74c818ebbfedd4fa076f">&#9670;&nbsp;</a></span>isUnsubscribeDone()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::isUnsubscribeDone </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Check the state of unsubscription. If there was received a unsubscription ACK, we return a true here. </p>
<dl class="section return"><dt>Returns</dt><dd>Is unsubscription validated with ACK (true/false) </dd></dl>

</div>
</div>
<a id="a49518d415ae1fc9a115712bb90bcbafb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a49518d415ae1fc9a115712bb90bcbafb">&#9670;&nbsp;</a></span>keepAliveChecker()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PubSubClient::keepAliveChecker </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This is a Timer called routine, which checks the PING_outstanding flag. This flag is set in this function. We send a Keep alive message to the server here. If there is a data in, or output, or we receive the MQTT ping request, the flag will be set to false by other functions. This function is called every MQTT_KEEPALIVE interval. If the flag is still true, we have a error with the connection. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">N/A.</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a59500b307e27b6ec9007ef1f3a0c24db"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a59500b307e27b6ec9007ef1f3a0c24db">&#9670;&nbsp;</a></span>publish() <span class="overload">[1/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::publish </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>topic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>payload</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Publish a MQTT message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">my</td><td>topic. [in] my payload. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success (true), or no success (false). </dd></dl>

</div>
</div>
<a id="a7daa0a786e0bcb8447cc2e9c5acaae7b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7daa0a786e0bcb8447cc2e9c5acaae7b">&#9670;&nbsp;</a></span>publish() <span class="overload">[2/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::publish </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>topic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>payload</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>retained</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Publish a MQTT message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">my</td><td>topic. [in] my payload. [in] is this a retained message (true/false) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success (true), or no success (false). </dd></dl>

</div>
</div>
<a id="a640422e51b06a9021140766928645a6d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a640422e51b06a9021140766928645a6d">&#9670;&nbsp;</a></span>publish() <span class="overload">[3/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::publish </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>topic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>payload</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>plength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Publish a MQTT message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">my</td><td>topic. [in] my payload. [in] length of the message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success (true), or no success (false). </dd></dl>

</div>
</div>
<a id="ad2cd5fb0bbd16f2b177faeda3ec3ca61"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad2cd5fb0bbd16f2b177faeda3ec3ca61">&#9670;&nbsp;</a></span>publish() <span class="overload">[4/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::publish </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>topic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>payload</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>plength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>retained</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Publish a MQTT message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">my</td><td>topic. [in] my payload. [in] length of the message [in] is this a retained message (true/false) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success (true), or no success (false). </dd></dl>

</div>
</div>
<a id="a115733ca6dd337362375d3c4a45300fe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a115733ca6dd337362375d3c4a45300fe">&#9670;&nbsp;</a></span>setCallback()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPubSubClient.html">PubSubClient</a> &amp; PubSubClient::setCallback </td>
          <td>(</td>
          <td class="paramtype">MQTT_CALLBACK_SIGNATURE&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the callback function for incoming data. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">callback</td><td>function </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>My instance. </dd></dl>

</div>
</div>
<a id="a30e35b9461d26f3d10736ac39c9de418"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a30e35b9461d26f3d10736ac39c9de418">&#9670;&nbsp;</a></span>setClient()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPubSubClient.html">PubSubClient</a> &amp; PubSubClient::setClient </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classSocket.html">Socket</a> &amp;&#160;</td>
          <td class="paramname"><em>client</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the socket, which we want to use for our MQTT communication. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">the</td><td>new socket instance </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>My instance. </dd></dl>

</div>
</div>
<a id="aa809b115adf6c551dee72d12ecfd8414"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa809b115adf6c551dee72d12ecfd8414">&#9670;&nbsp;</a></span>setServer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPubSubClient.html">PubSubClient</a> &amp; PubSubClient::setServer </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>ip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>port</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set server ip and Port of my MQTT server. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">ip</td><td>of the distant MQTT server. [in] the port of the distant MQTT port. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>My instance. </dd></dl>

</div>
</div>
<a id="a8a7025562e55ee15fd4469b75d535b1d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8a7025562e55ee15fd4469b75d535b1d">&#9670;&nbsp;</a></span>state()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int PubSubClient::state </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the current MYTT state form the instance. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">N/A.</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>current MQTT state. </dd></dl>

</div>
</div>
<a id="a62ae269568ef379fb21a434f7e6d4a06"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a62ae269568ef379fb21a434f7e6d4a06">&#9670;&nbsp;</a></span>subscribe()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::subscribe </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>topic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>ack</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Subscribe a MQTT topic. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">my</td><td>topic [in] qos of subscription </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>request transmitted with success (true), or no success (false). </dd></dl>

</div>
</div>
<a id="ac67061f0fdd7b98007f6f7501b6a5dbd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac67061f0fdd7b98007f6f7501b6a5dbd">&#9670;&nbsp;</a></span>timeoutChecker()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PubSubClient::timeoutChecker </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This is a Timer called routine, which is called, when we reach the timeout. Used is this function for all ACK commands, which comes over MQTT. Notice, that the KeepAlivePing has his own Timer, to prevent conflicts. Basically, if this function is called, we have detected a MQTT timeout! </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">N/A.</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="af828241dd14833967c27b902b43b6491"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af828241dd14833967c27b902b43b6491">&#9670;&nbsp;</a></span>unsubscribe()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PubSubClient::unsubscribe </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>topic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>ack</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Unsubscribe a MQTT topic. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">my</td><td>topic [in] qos of unsubscription </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>request transmitted with success (true), or no success (false). </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="PubSubClient_8h_source.html">PubSubClient.h</a></li>
<li>PubSubClient.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
